package io.gitlab.arturbosch.detekt.core.processors.util

import io.gitlab.arturbosch.detekt.api.DetektVisitor
import org.jetbrains.kotlin.psi.KtElement

inline fun <reified T : KtElement> KtElement.collectByType(): List<T> {
    val list = mutableListOf<T>()
    this.accept(object : DetektVisitor() {
        override fun visitKtElement(element: KtElement) {
            if (element is T) {
                list.add(element)
            }
            element.children.forEach { it.accept(this) }
        }
    })
    return list
}
